// PSF90614ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PSF90614Example.h"
#include "PSF90614ExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const TCHAR* g_szAppName = _T("PSF90614 Example");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPSF90614ExampleDlg dialog

CPSF90614ExampleDlg::CPSF90614ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPSF90614ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPSF90614ExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_idTimer = 0;
}

void CPSF90614ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPSF90614ExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPSF90614ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CPSF90614ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDCONNECT, OnConnect)
	ON_BN_CLICKED(IDDISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDSTARTSTOP, OnStartstop)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPSF90614ExampleDlg message handlers

BOOL CPSF90614ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPSF90614ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPSF90614ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPSF90614ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPSF90614ExampleDlg::OnConnect() 
{
	USES_CONVERSION;
	HRESULT hRes;
	CComPtr<IDispatch> pDisp;

	if (m_pDev.p != NULL)
		Disconnect();

	// Auto connect to the EVB

	// Create a device object
	hRes = m_pDev.CoCreateInstance(CLSID_PSF090614EVMLXDevice, NULL, CLSCTX_INPROC);

	// Check if the device has correct setup. This method will auto-search the available channels.
	if (SUCCEEDED(hRes))
		hRes = m_pDev->CheckSetup(VARIANT_FALSE);
	if (SUCCEEDED(hRes))
		hRes = m_pDev->put_ResponseTimeout(10000);

	// Get the actual name of the attached communication channel
	if (SUCCEEDED(hRes))
		hRes = m_pDev->get_Channel(&pDisp);
	CComPtr<IMPTChannel> pChan;
	CComBSTR bstrName;
	if (SUCCEEDED(hRes))
		pDisp->QueryInterface(IID_IMPTChannel, (void**)&pChan);
	pDisp.Release();
	if (SUCCEEDED(hRes))
		pChan->get_Name(&bstrName);
	if (SUCCEEDED(hRes))
	{
		CString str(_T("Connected to "));
		str += OLE2T(bstrName);
		this->SetDlgItemText(IDC_CONNECTEDTXT, str);
	}
	else
		MessageBox(_T("Cannot connect to device"), g_szAppName, MB_OK|MB_ICONERROR);
}

void CPSF90614ExampleDlg::Disconnect()
{
	if (m_idTimer != 0)
	{
		if (IsWindow(m_hWnd))
		{
			KillTimer(m_idTimer);
		}
		m_idTimer = 0;
	}
	if (IsWindow(m_hWnd))
	{
		this->SetDlgItemText(IDC_CONNECTEDTXT, _T("Disconnected"));
		this->SetDlgItemText(IDSTARTSTOP, _T("&Start"));
	}

	if (m_pDev.p != NULL)
	{
		// Power off
		m_pDev->CmdSetSupplyVoltage(0);

		// Release device object and the attached channel
		m_pDev->Destroy(VARIANT_TRUE);
		m_pDev.Release();
	}
}

void CPSF90614ExampleDlg::OnDisconnect() 
{
	Disconnect();
}

void CPSF90614ExampleDlg::OnStartstop() 
{
	if (m_idTimer != 0)
	{
		KillTimer(m_idTimer);
		m_idTimer = 0;
		this->SetDlgItemText(IDSTARTSTOP, _T("&Start"));
		return;
	}

	if (m_pDev.p == NULL)
	{
		MessageBox(_T("No connection to a device.\nPlease use Connect button to establish a connection."), 
			g_szAppName, MB_OK);
		return;
	}

	if (FAILED(InitModule()))
	{
		MessageBox(_T("Unable to get data from the module"), g_szAppName, MB_OK|MB_ICONERROR);
		return;
	}
	m_idTimer = SetTimer(1, 500, 0);
	if (m_idTimer == 0)
	{
		MessageBox(_T("Unable to start timer"), g_szAppName, MB_OK|MB_ICONERROR);
		return;
	}
	this->SetDlgItemText(IDSTARTSTOP, _T("&Stop"));
}

HRESULT CPSF90614ExampleDlg::InitModule()
{
	if (m_pDev.p == NULL)
		return E_FAIL;
	unsigned char btVolt;
	CComVariant var;
	HRESULT hRes = m_pDev->CmdCheckModuleVersion(&btVolt, 2, &var);
	if (SUCCEEDED(hRes) && (var.vt != VT_BSTR || ::SysStringByteLen(var.bstrVal) == 0))
		hRes = E_UNEXPECTED;

	// Set SMB address of the first found module
	if (SUCCEEDED(hRes))
		hRes = m_pDev->SetSMBAddress(LOBYTE(var.bstrVal[0]));

	// Invalidate EEPROM cache
	if (SUCCEEDED(hRes))
		hRes = m_pDev->DeviceReplaced();

	// Get min and max temperature values
	var.Clear();
	if (SUCCEEDED(hRes))
		hRes = m_pDev->GetEEParameterValue(CodeTomin, &var);
	if (SUCCEEDED(hRes))
	{
		m_fTomin = var.fltVal;
		var.Clear();
		hRes = m_pDev->GetEEParameterValue(CodeTomax, &var);
	}
	if (SUCCEEDED(hRes))
	{
		m_fTomax = var.fltVal;
		var.Clear();
		hRes = m_pDev->GetEEParameterValue(CodeTamin, &var);
	}
	if (SUCCEEDED(hRes))
	{
		m_fTamin = var.fltVal;
		var.Clear();
		hRes = m_pDev->GetEEParameterValue(CodeTamax, &var);
	}
	if (SUCCEEDED(hRes))
	{
		m_fTamax = var.fltVal;
		CString str;
		str.Format(_T("%.0f"), m_fTomin);
		this->SetDlgItemText(IDC_MINTEMP, str);
		str.Format(_T("%.0f"), m_fTomax + 0.5f);
		this->SetDlgItemText(IDC_MAXTEMP, str);
		str.Format(_T("%.0f"), m_fTamin);
		this->SetDlgItemText(IDC_MINTEMP3, str);
		str.Format(_T("%.0f"), m_fTamax + 0.5f);
		this->SetDlgItemText(IDC_MAXTEMP3, str);
		CProgressCtrl* progress = (CProgressCtrl*)GetDlgItem(IDC_TOBJ1PROGRESS);
		if (::IsWindow(progress->m_hWnd))
			progress->SetRange32((int)m_fTomin, (int)(m_fTomax+0.5f));
		progress = (CProgressCtrl*)GetDlgItem(IDC_TAMBPROGRESS);
		if (::IsWindow(progress->m_hWnd))
			progress->SetRange32((int)m_fTamin, (int)(m_fTamax+0.5f));
	}

	return hRes;
}

void CPSF90614ExampleDlg::OnTimer(UINT nIDEvent) 
{
	if (m_pDev.p == NULL)
		return;

	#define RAMADDR_TAMB	6
	#define RAMADDR_TOBJ1	7
	#define RAMADDR_TOBJ2	8

	static const float fK0 = -273.15f;

	HRESULT hRes;
	long l;
	float f;
	CString str;
	
	// Show Tobj1
	CProgressCtrl* progress = (CProgressCtrl*)GetDlgItem(IDC_TOBJ1PROGRESS);
	if (m_idTimer != 0 && ::IsWindow(progress->m_hWnd))
	{
		hRes = m_pDev->CmdReadRam(RAMADDR_TOBJ1, &l);
		f = (float)((unsigned short)l)/50 + fK0;
		if (SUCCEEDED(hRes) && m_fTomin <= f && f <= m_fTomax)
		{
			progress->SetPos((int)f);
			str.Format(_T("%.1f"), f);
			SetDlgItemText(IDC_TOBJ1EDIT, str);
		}
		else
		{
			progress->SetPos((int)m_fTomin);
			SetDlgItemText(IDC_TOBJ1EDIT, _T("---"));
		}
	}
	
	// Show Tamb
	progress = (CProgressCtrl*)GetDlgItem(IDC_TAMBPROGRESS);
	if (m_idTimer != 0 && ::IsWindow(progress->m_hWnd))
	{
		hRes = m_pDev->CmdReadRam(RAMADDR_TAMB, &l);
		f = (float)((unsigned short)l)/50 + fK0;
		if (SUCCEEDED(hRes) && m_fTamin <= f && f <= m_fTamax)
		{
			progress->SetPos((int)f);
			str.Format(_T("%.1f"), f);
			SetDlgItemText(IDC_TAMBEDIT, str);
		}
		else
		{
			progress->SetPos((int)m_fTomin);
			SetDlgItemText(IDC_TAMBEDIT, _T("---"));
		}
	}

	//CDialog::OnTimer(nIDEvent);
}

// Used to disable exiting on ESCAPE
BOOL CPSF90614ExampleDlg::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
		return TRUE;
	return CDialog::PreTranslateMessage(pMsg);
}
